"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const chalk = require("chalk");
const cli_utils_1 = require("@ionic/cli-utils");
const cli_utils_2 = require("@ionic/cli-utils");
let LoginCommand = class LoginCommand extends cli_utils_1.Command {
    run(inputs, options) {
        return __awaiter(this, void 0, void 0, function* () {
            let [email, password] = inputs;
            if (!email) {
                this.env.log.msg(`Log into your Ionic account\n` +
                    `If you don't have one yet, create yours by running: ${chalk.green(`ionic signup`)}\n`);
                const response = yield this.env.inquirer.prompt({
                    name: 'email',
                    type: 'input',
                    message: 'Email:',
                    validate: cli_utils_2.combine([cli_utils_2.validators.required, cli_utils_2.validators.email])
                });
                email = response['email'];
            }
            if (!password) {
                const response = yield this.env.inquirer.prompt({
                    name: 'password',
                    type: 'password',
                    message: 'Password:',
                    validate: cli_utils_2.combine([cli_utils_2.validators.required])
                });
                email = response['password'];
            }
            yield this.env.session.login(email, password);
            this.env.log.ok('You are logged in!');
        });
    }
};
LoginCommand = __decorate([
    cli_utils_1.CommandMetadata({
        name: 'login',
        description: 'Login with your Ionic ID',
        exampleCommands: ['john@example.com'],
        inputs: [
            {
                name: 'email',
                description: 'Your email address'
            },
            {
                name: 'password',
                description: 'Your password'
            }
        ]
    })
], LoginCommand);
exports.LoginCommand = LoginCommand;
